// #autoload
// #name = jsutirc
// #version = 0.0.7
// #date = Sept 29, 2001
// #author = [PEN]jsut
// #warrior =  jsut
// #email = jsut@kabob.ca
// #description = jsut's T2 IRC client extentions
// #status = release?
// #config = JsutIrcConfigGui
// #readme = jsut/readme.txt
// #category = jsut

// globals
$jsutPref::channels = "jsut/jsutirc.ini";
$jsutPref::config = "jsut/jsutpref.cs";
$jsutPref::refreshChannels = 0;
$jsutPref::IRCMode = 0;

//---------------------------------------------------------
// toggles the value of $jsutPref::IRCMode, and echos a message
// to the MessageHUD
//
function jsutToggleIRCMode(%val)
{
    if (!$jsutInGame || !%val)
        return;
    
    if ($jsutPref::IRCMode) {
        $jsutPref::IRCMode = 0;
        addMessageHudLine("\c5IRCMode Deactivated" );
    }else{
        $jsutPref::IRCMode = 1;
        addMessageHudLine("\c5IRCMode Activated" );
    }
}


//---------------------------------------------------------
// This is a better version of SetOperator, that takes an arbitrary channel name, so it'll
// op people outside of your current channel
//
function IRCClient::jsutSetOperator(%p,%channel)
{
   IRCClient::send("MODE " @ %channel @ " +o " @ %p.displayName);
}

//---------------------------------------------------------
// implement /who, probably not that useful since everyone is +i
//
function IRCClient::jsutWho(%glob)
{
   IRCClient::send("WHO" SPC %glob);
   //error("WHO " @ %glob);
}

//---------------------------------------------------------
//  this implements /msg, but you have to know the person's real server nick
//
function IRCClient::jsutMSG(%params)
{
   %params = nextToken(%params,target," ");
   
   %p = IRCClient::jsutFindPerson(%target);
   if (%p.displayName !$= "") { %target = %p.displayName; }
   
   IRCClient::send("PRIVMSG " @ %target @ " :" @ %params);
}

//---------------------------------------------------------
//  this implements /amsg
//
function IRCClient::jsutAMSG(%params)
{
   %me = $IRCClient::people.getObject(0);
   for (%i = 0; %i < $IRCClient::channels.getCount(); %i++)
   {
       %c = $IRCClient::channels.getObject(%i);
       if (strpos(%c.getName(), "#") != -1) {
           IRCClient::send("PRIVMSG " @ %c.getName() @ " :" @ %params);
           IRCClient::newMessage(%c.getName(), IRCClient::taggedNick(%me) @ ": " @ %params);
       }
   }
}

//---------------------------------------------------------
//  this implements /ame
//
function IRCClient::jsutAME(%params)
{
   %me = $IRCClient::people.getObject(0);
   for (%i = 0; %i < $IRCClient::channels.getCount(); %i++)
   {
       %c = $IRCClient::channels.getObject(%i);
       if (strpos(%c.getName(), "#") != -1) {
           IRCClient::send("ACTION " @ %c.getName() @ " :" @ %params);
           IRCClient::newMessage(%c.getName(), IRCClient::taggedNick(%me) @ "\c9 " @ %params);
       }
   }
}

//---------------------------------------------------------
//  this implements /whois, but you have to know the person's real server nick
//
function IRCClient::jsutWhois(%params)
{
   IRCClient::send("WHOIS " @ %params);
}

//---------------------------------------------------------
//  tries to find a person based on just the white part of their nick.  May be buggy.
//  since i think people that have weird characters in their names have weird server 
//  nicks.
//
function IRCClient::jsutFindPerson(%nick)
{
   for (%i = 0; %i < $IRCClient::people.getCount(); %i++)
   {
      %person = $IRCClient::people.getObject(%i);
      if (%person.nameonly $= %nick)
        return %person;
   }
}

//---------------------------------------------------------
// The package
//
package jsutirc {

//
//  Autojoin stuff.
//
    function ChatGui::onWake(%this) {
        parent::onWake( %this );
        
        $jsutPref::chatEntered = true;        
        
        // only autojoin if the file has been messed with, or we just started
        //
        if ( !$autojoinchannels || $jsutPref::refreshChannels != 0) {
            
            // get list, cache in memory
            //
            $jsutPref::refreshChannels = 0;
            %file = new FileObject();
            if(!%file.openForRead($jsutPref::channels))
            {
                %file.delete();
                return;
            }
        
            for(%i = 1; !%file.isEOF(); %i++) {
                $autojoinchannels[%i] = %file.readLine();
                
                // only join channels we aren't in
                if ( !IRCClient::findChannel(IRCClient::channelName($autojoinchannels[%i])) && $autojoinchannels[%i] !$= "") {
                    IRCClient::join(IRCClient::channelName($autojoinchannels[%i]));
                    //error("autojoined " @ $autojoinchannels[%i] );
                }
                $autojoinchannels = %i;
            }
            %file.close();
            %file.delete();
        }else{
            for(%i = 0; %i < $autojoinchannels; %i++) {
                if ( !IRCClient::findChannel(IRCClient::channelName($autojoinchannels[%i])) && $autojoinchannels[%i] !$= "") {
                    IRCClient::join(IRCClient::channelName($autojoinchannels[%i]));
                    //error("autojoined " @ $autojoinchannels[%i] );
                }
            }
        }
    }

//---------------------------------------------------------
//  This adds stuff to right click context menus
//
    function ChatRoomMemberList::onRightMouseDown(%this,%column,%row,%mousePos) 
    {
        parent::onRightMouseDown( %this,%column,%row,%mousePos );
        %p = ChatMemberPopup.member;
        ChatMemberPopup.add("Whois",5550);
        //ChatMemberPopup.add( %p.displayName ,5551);
    }

//---------------------------------------------------------
// This adds the function calls for the things added to the context menu
//
    function ChatMemberPopup::onSelect(%this,%id,%text)
    {
        switch( %id )
        {
            case 5550:  // Whois
                IRCClient::whois(ChatMemberPopup.member);

            default: // go to parent
                parent::onSelect(%this,%id,%text);
        }
    }

//---------------------------------------------------------
//  This is the part that does the Auto Op action
//   
    function IRCClient::onJoin(%prefix,%params) {
        
        %c = IRCClient::findChannel(%params,true);
        %channel = %c.getName();
        
        %p = IRCClient::findPerson2(%prefix,true);
                
        %me = $IRCClient::people.getObject(0);
        %im = %c.findMember(%me);
        
        // in our tribe, and i have ops, op them.
        //
        if ( $jsutPref::Autoop && %p.tribe $= %me.tribe && %c.getFlags(%im) & $PERSON_OPERATOR) {
            IRCClient::jsutSetOperator(%p,%channel);
        }
        
        // display the servername
        if ($jsutPref::ShowServerNick) {
            IRCClient::newMessage(%c,"\c4"@ %p.nick @ " = " @ %p.displayName );
        }
        
        // in game join announce
        if ($jsutInGame == 1 && $jsutPref::InGameJoinAnnounce) {
            addMessageHudLine("\c5" @ %p.nick @ " joined " @ %channel);
        }
        
        parent::onJoin(%prefix,%params);
    }

//---------------------------------------------------------
//  This is the part that sets your away message
//    
    function IRCClient::onJoinGame(%address, %desc) {
        parent::onJoinGame(%address, %desc);
        $jsutInGame = 1;
        IRCClient::send("AWAY :" @ "in game " @ %address @ " - " @ %desc);
    }

//---------------------------------------------------------
//  This is the part that sets your away message
//    
    function IRCClient::onLeaveGame()
    {
       $jsutInGame = 0;
       $jsutPref::IRCMode = 0;
       parent::onLeaveGame();
    }

//---------------------------------------------------------
//  This is the part that adds the .tribe property to each
//  member's identity.  it's used for auto oping.
//    
    function IRCClient::setIdentity(%p,%ident) {

       parent::setIdentity(%p,%ident);
       
       %nick = %p.displayName;
       %p.tribe = "";
       
       if (strpos(%nick, "^") != -1)
       {
          %triple = IRCGetTriple(%nick);
          %name = getField(%triple, 0);
          %tag = getField(%triple, 1);
          %append = getField(%triple, 2);
          %p.tribe = %tag;
          %p.nameonly = %name;
       }
    }
    
//---------------------------------------------------------
//  This adds the dispatching for the /commands that i've added support for
//
    function IRCClient::send2(%message,%to) {
       
       if ((strcmp($IRCCLient::state,IDIRC_CONNECTING_IRC) && strcmp($IRCClient::state,IDIRC_CONNECTED)) ||
           !strlen(%message))
          return;
    
       if (getSubStr(%message,0,1) $= "/")   
       {
          %buffer = getSubStr(%message,1,strlen(%message)-1);
          %params = nextToken(%buffer,command," ");
    
         // dispatch the command to a handler -- if one exists
         // we don't need to handle all outgoing commands just a few
         switch$(%command)
         {
           case "AME":
               IRCClient::jsutAME(%params);
           case "AMSG":
               IRCClient::jsutAMSG(%params);
           case "MSG":
               IRCClient::jsutMSG(%params);
           case "WHO":
               IRCClient::jsutWho(%params);
           case "WHOIS":
               IRCClient::jsutWhois(%params);
    
           default:
             // otherwise ship it to the server, RAW
              parent::send2(%message,%to);
         }
       }
       else {
           parent::send2(%message,%to);
       }
    }

//---------------------------------------------------------
//  These three whois functions display an MIRC style /whois response.  
//  The next funness will be to implement /whois itself.  They don't call
//  the parent functions because they are dumb (IMHO). 
//
//  v0.0.6
//  completely disabled parent functions, cause they now write stuff out
//  to a pane which doesn't exist
//
    function IRCClient::onWhoisReply(%prefix,%params)
    {
        %params = nextToken(%params,nick," ");
        IRCClient::newMessage($IRCClient::currentChannel.getName(),%params);
    }
    function IRCClient::onWhoisUserReply(%prefix,%params)
    {
        %params = nextToken(%params,nick," ");
        IRCClient::newMessage($IRCClient::currentChannel.getName(),%params);
    }
    function IRCClient::onWhoisIdle(%prefix,%params)
    {
        %params = nextToken(%params,nick," ");
        IRCClient::newMessage($IRCClient::currentChannel.getName(),%params);
    }

//---------------------------------------------------------
// logging is implemented in here.
//
    function IRCClient::newMessage(%channel,%message) {
        parent::newMessage(%channel,%message);
        
        
        if (ChatGui.awake != true && $jsutPref::chatEntered == true && $jsutingame == 0 && $jsutPref::ding) {
            %handle = alxCreateSource( AudioChat, "gui/buttonOver.wav" );
            alxPlay( %handle );
        }
        
        if ($CurrentDate !$= "" && $CurrentTime[24] !$= "") {
            $timestamp = "[" @ $CurrentDate @ ":" @ $CurrentTime[24] @ "]";
            $timestamp = strreplace($timestamp," ","");
            $timestamp = $timestamp @ " ";
        }else{
            $timestamp = "";
        }
        
        if ($jsutPref::Logging || $jsutPref::IRCMode){
        
            // strip stuff
            %message = strreplace(%message,"<tribe:1>","");
            %message = strreplace(%message,"<tribe:0>","");
            %message = strreplace(%message,"</tribe>","");
            %message = strreplace(%message,"\c1","");
            %message = strreplace(%message,"\c2","");
            %message = strreplace(%message,"\c3","");
            %message = strreplace(%message,"\c4","");
            %message = strreplace(%message,"\c5","");
            %message = strreplace(%message,"\c6","");
            %message = strreplace(%message,"\c7","");
            %message = strreplace(%message,"\c8","");
            %message = strreplace(%message,"\c9","");
            
            if ($jsutPref::IRCMode) {
                addMessageHudLine("\c5(" @ %channel.getName() @") " @ %message );
            }
            
            if ($jsutPref::Logging && !%channel.logfileHandle && %channel && %channel.getName() !$= "" && %channel.getName() !$= "STATUS") {
    
                // strip bad characters
                %filename = %channel.getName();
                %filename = strreplace(%filename,"*","_");
                %filename = strreplace(%filename,"/","_");
                %filename = strreplace(%filename,"\\","_");
                %filename = strreplace(%filename,":","_");
                %filename = strreplace(%filename,"?","_");
                %filename = strreplace(%filename,"\"","_");
                %filename = strreplace(%filename,">","_");
                %filename = strreplace(%filename,"<","_");
                %filename = strreplace(%filename,"|","_");

                %file = new FileObject();
            
                // altered code from Writer file_utils.cs 
                // i need a way to seek to the end of a file without rewriting it
                //
                if(%file.openForAppend("jsut/logs/" @ %filename)) {
                }else{
                    error('cannot write to logfile');
                }
                %channel.logfileHandle = %file;
                %channel.logfileHandle.writeLine("");
                %channel.logfileHandle.writeLine("Session Opened " @ $timestamp);
                %channel.logfileHandle.writeLine($timestamp @ %message);
            }else{
                if (%channel && %channel.getName() !$= "" && %channel.logfileHandle && %channel.getName() !$= "STATUS") {
                    %channel.logfileHandle.writeLine($timestamp @ %message);
                }
            }
        }
    }

//---------------------------------------------------------
//  This closes the logfileHandle when you close the window.
//
    function ChatTabView::closeCurrentPane(%this){
        if ($jsutPref::Logging){
            $IRCClient::currentChannel.logfileHandle.writeLine("Session Ended");
            $IRCClient::currentChannel.logfileHandle.writeLine("");
            $IRCClient::currentChannel.logfileHandle.close();
            $IRCClient::currentChannel.logfileHandle.delete();
        }
        parent::closeCurrentPane(%this);
    }

//---------------------------------------------------------
//  echo nosuch nick messages to your current channel
//
    function IRCClient::onNoSuchNick(%prefix,%params)
    {
        IRCClient::newMessage($IRCClient::currentChannel.getName(), %params);     
        parent::onNoSuchNick(%prefix,%params);
    }
    
//---------------------------------------------------------
// Disable Annoying colon filter.  This function isn't used anywhere other
// than ChatGui.cs in 23667.  TextCheck is used in webforums.cs, but has
// had it's guts removed to do exactly what i'm making this function do.
// seems like a bug from dynamix to me.
//
    function TextCheck2(%text,%handler) {
        %handler.textCheck = 0;
    }

//---------------------------------------------------------
//  This makes the ChatMessageEntry dissappear when you
//  click onto the WELCOME pane
//
    function ChatTabView::onSelect(%this,%obj,%name)
    {
        
        if (%name $= "WELCOME")
        {
            if ($jsutPref::Status == 1){
                %name = "STATUS";
            }else{
                ChatMessageEntry.setVisible(false);
            }
        }else{
            ChatMessageEntry.setVisible(true);
        }
        parent::onSelect(%this,%obj,%name);
    }

//---------------------------------------------------------
//  All stuff coming from the server goes through this.  It's essentially 
//  for debugging
//
//    function IRCClient::dispatch(%prefix,%command,%params) {
//        if (%command $= "PRIVMSG") {}else{
//            IRCClient::newMessage($IRCClient::currentChannel.getName(),%prefix SPC %command SPC %params);
//        }
//        parent::dispatch(%prefix,%command,%params);
//    }

//---------------------------------------------------------
//  This function makes it so you can send messages back to IRC from within
//  the game when IRCMode is on
//
    function MessageHud_Edit::eval(%this)
    {
        %text = trim(%this.getValue());
        if (getSubStr(%text,0,1) $= "#" && $jsutPref::IRCMode) {
            
            %me = $IRCClient::people.getObject(0);
            %text = nextToken(%text,channel," ");
            
            if (%channel $= "#") {
                %channel = $IRCClient::currentChannel.getName();
            }
            
            IRCClient::send("PRIVMSG " @ %channel @ " :" @ %text);
            IRCClient::newMessage(%channel, IRCClient::taggedNick(%me) @ ": " @ %text);
            
            // don't double echo if IRCMode is on
            //
            if (!$jsutPref::IRCMode)
                addMessageHudLine("\c5(" @  %channel @") " @ IRCClient::displayNick(%me) @ ":" @ %text);

            MessageHud.close();
        }else{
            parent::eval(%this);
        }
    }
    
    function ChatTabView::onAdd(%this)
    {
        
        error("hi outside");
        if ($jsutPref::Status == 1){
            error("hi");
            %this.addTab($IRCClient::channels.getObject(0),"STATUS");
        }else{
            //parent::onAdd(%this);
        }
    }
    
};

activatePackage(jsutirc);

// add the IRC Mode Toggle keybind
//
$RemapName[$RemapCount]="Toggle IRC Mode";
$RemapCmd[$RemapCount]="jsutToggleIRCMode";
$RemapCount++;

// exec the prefs if they are there.
if (isfile($jsutPref::config)) { 
    exec($jsutPref::config);
}else{
    // default prefs
    $jsutPref::InGameJoinAnnounce = 0;
    $jsutPref::ShowServerNick = 0;
    $jsutPref::ding = 0;
    $jsutPref::Logging = 0;
    $jsutPref::TimeStampLogs = 0;
    $jsutPref::Scrollback = 10;
    $jsutPref::autoop = 10;
}

//
//  the following code deletes the ChatMessageEntry from Dynamix
//  and replaces it with an identical one, that has historySize
//  set to something useful.
//
if ($jsutPref::Scrollback > 0) {
    ChatMessageEntry.delete();
    $jsutChatMessageEntry = new ShellTextEditCtrl(ChatMessageEntry) {
				profile = "NewTextEditProfile";
				horizSizing = "width";
				vertSizing = "top";
				position = "27 370";
				extent = "392 38";
				minExtent = "32 38";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				altCommand = "ChatSendText();";
				helpTag = "0";
				maxLength = "255";
				historySize = $jsutPref::Scrollback;
				password = "0";
				tabComplete = "1";
				deniedSound = "InputDeniedSound";
				glowOffset = "9 9";
			};

    ChatChannelPane.add($jsutChatMessageEntry);
}    

// gui stuff i barely understand.  ripped from writer and pj

    if( !isObject(JsutIrcConfigGui) )
    {
        new GuiControl(JsutIrcConfigGui) {
        	profile = "GuiDefaultProfile";
        	horizSizing = "width";
        	vertSizing = "height";
        	position = "0 10";
        	extent = "400 310";
        	minExtent = "8 8";
        	visible = "1";
        	helpTag = "0";

	        new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 5";
			extent = "130 30";
			minExtent = "26 27";
			visible = "1";
			variable = "$jsutPref::InGameJoinAnnounce";
			helpTag = "0";
			text = "In Game Join Announce";
			maxLength = "255";
		};
	        new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "140 5";
			extent = "130 30";
			minExtent = "26 27";
			visible = "1";
			variable = "$jsutPref::ShowServerNick";
			helpTag = "0";
			text = "Show Server Nicks";
			maxLength = "255";
		};
	        new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "275 5";
			extent = "130 30";
			minExtent = "26 27";
			visible = "1";
			variable = "$jsutPref::ding";
			helpTag = "0";
			text = "jsut's dinger";
			maxLength = "255";
		};
	        new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "5 30";
			extent = "130 30";
			minExtent = "26 27";
			visible = "1";
			variable = "$jsutPref::Logging";
			helpTag = "0";
			text = "Enable Logging";
			maxLength = "255";
		};
	        new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "140 30";
			extent = "130 30";
			minExtent = "26 27";
			visible = "1";
			variable = "$jsutPref::TimeStampLogs";
			helpTag = "0";
			text = "Timestamp Logs";
			maxLength = "255";
		};		

	        new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "275 30";
			extent = "130 30";
			minExtent = "26 27";
			visible = "1";
			variable = "$jsutPref::Status";
			helpTag = "0";
			text = "Enable Status Window";
			maxLength = "255";
		};		

	        new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "275 55";
			extent = "130 30";
			minExtent = "26 27";
			visible = "1";
			variable = "$jsutPref::Autoop";
			helpTag = "0";
			text = "Enable Auto Op";
			maxLength = "255";
		};		

    		new GuiTextCtrl() {
    			profile = "ShellMediumTextProfile";
    			horizSizing = "right";
    			vertSizing = "bottom";
    			position = "15 60";
    			extent = "150 22";
    			minExtent = "8 8";
    			visible = "1";
    			helpTag = "0";
    			text = "ScrollBack Buffer Length:";
    			maxLength = "255";
    		};
		new ShellTextEditCtrl(JsutScrollInput) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "180 55";
			extent = "100 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			altCommand = "JsutIrcConfigGui::scrollChange();";
			helpTag = "0";
			maxLength = "255";
		};
    		new GuiTextCtrl() {
    			profile = "ShellMediumTextProfile";
    			horizSizing = "right";
    			vertSizing = "bottom";
    			position = "15 85";
    			extent = "150 32";
    			minExtent = "8 8";
    			visible = "1";
    			helpTag = "0";
    			text = "Edit your autojoin channels file:";
    			maxLength = "255";
    		};
    		new ShellScrollCtrl() {
    			profile = "NewScrollCtrlProfile";
    			horizSizing = "width";
    			vertSizing = "height";
    			position = "4 100"; 
    			extent = "380 150"; 
    			minExtent = "24 52";
    			visible = "1";
    			helpTag = "0";
    			willFirstRespond = "1";
    			hScrollBar = "alwaysOff";
    			vScrollBar = "alwaysOn";
    			constantThumbHeight = "0";
    			defaultLineHeight = "15";
    			childMargin = "3 3";
    			fieldBase = "gui/shll_field";

    			new GuiScrollContentCtrl() {
    				profile = "GuiDefaultProfile";
    				horizSizing = "width";
    				vertSizing = "height";
    				position = "7 7";
    				extent = "350 226"; 
    				minExtent = "8 8";
    				visible = "1";
    				helpTag = "0";

    				new GuiMLTextEditCtrl(ChannelsEdit) {
    					profile = "ShellMessageTextProfile";
    					horizSizing = "width";
    					vertSizing = "height";
    					position = "0 0";
    					extent = "350 226"; 
    					minExtent = "8 8";
    					visible = "1";
    					helpTag = "0";
    					lineSpacing = "2";
    					allowColorChars = "0";
    					maxChars = "10000";
    					deniedSound = "InputDeniedSound";
    				};
    			};
    		};

    		new ShellBitmapButton(JsutIrcReloadBtn) {
    			profile = "ShellButtonProfile";
    			horizSizing = "right";
    			vertSizing = "top";
    			position = "4 250";
    			extent = "85 38";
    			minExtent = "32 38";
    			visible = "1";
    			command = "JsutIrcConfigGui::Reload();";
    			helpTag = "0";
    			text = "RELOAD";
    			simpleStyle = "0";
    		};
    		new ShellBitmapButton(JsutIrcSaveBtn) {
    			profile = "ShellButtonProfile";
    			horizSizing = "right";
    			vertSizing = "top";
    			position = "80 250"; 
    			extent = "85 38";
    			minExtent = "32 38";
    			visible = "1";
    			command = "JsutIrcConfigGui::save();";
    			helpTag = "0";
    			text = "SAVE";
    			simpleStyle = "0";
    		};
    	};
    }


//-----------------------------------------------------------------------------
function JsutIrcConfigGui::init(%this, %extent)
{
}
//-----------------------------------------------------------------------------
function JsutIrcConfigGui::onWake(%this)
{
        %file = new FileObject();
        ChannelsEdit.setValue( %file.getContents($jsutPref::channels));
        %file.close();
        %file.delete();
        JsutScrollInput.setValue($jsutPref::Scrollback);
}
//-----------------------------------------------------------------------------
function JsutIrcConfigGui::scrollChange(%this)
{
    %input = JsutScrollInput.getValue();
    if (isNumeric(%input)) {
        $jsutPref::Scrollback = %input;
    }else{
        JsutScrollInput.setValue("0");
    }
}
//-----------------------------------------------------------------------------
function JsutIrcConfigGui::reload(%this)
{
        %file = new FileObject();
        ChannelsEdit.setValue( %file.getContents($jsutPref::channels));
        %file.close();
        %file.delete();
}
//-----------------------------------------------------------------------------
function JsutIrcConfigGui::save(%this)
{
        %file = new FileObject();
        %file.write( $jsutPref::channels, ChannelsEdit.getValue() );
        %file.close();
        %file.delete();
        $jsutPref::refreshChannels = 1;
        
        %file = new FileObject();
        %file.openForWrite($jsutPref::config);
        %file.writeLine("$jsutPref::InGameJoinAnnounce = " @ $jsutPref::InGameJoinAnnounce @";");
        %file.writeLine("$jsutPref::ShowServerNick = " @ $jsutPref::ShowServerNick @";");
        %file.writeLine("$jsutPref::ding = " @ $jsutPref::ding @";");
        %file.writeLine("$jsutPref::Scrollback = " @ $jsutPref::Scrollback @";");
        %file.writeLine("$jsutPref::Logging = " @ $jsutPref::Logging @";");
        %file.writeLine("$jsutPref::TimeStampLogs = " @ $jsutPref::TimeStampLogs @";");
        %file.writeLine("$jsutPref::Status = " @ $jsutPref::Status @";");
        %file.writeLine("$jsutPref::Autoop = " @ $jsutPref::Autoop @";");
        
        %file.close();
        %file.delete();
}
